// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.


import HTTP

public extension Bot {

    /**
     Use this method to get current webhook status. Requires no parameters. On success, returns a WebhookInfo object. If the bot is using getUpdates, will return an object with the url field empty.

     SeeAlso Telegram Bot API Reference:
     [GetWebhookInfoParams](https://core.telegram.org/bots/api#getwebhookinfo)
     
     - Parameters:
         - params: Parameters container, see `GetWebhookInfoParams` struct
     - Throws: Throws on errors
     - Returns: Future of `WebhookInfo` type
     */
    @discardableResult
    func getWebhookInfo() throws -> Future<WebhookInfo> {
        let response: Future<TelegramContainer<WebhookInfo>>
        response = try client.respond(endpoint: "getWebhookInfo", body: HTTPBody(), headers: HTTPHeaders())
        return response.flatMap(to: WebhookInfo.self) { try self.wrap($0) }
    }
}
